Index: trunk/kernel/syscalls/sys_barrier.c
===================================================================
--- trunk/kernel/syscalls/sys_barrier.c	(revision 690)
+++ trunk/kernel/syscalls/sys_barrier.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_barrier.c - Access a POSIX barrier.
+ * kern/sys_barrier.c - barrier service interface for userland
  * 
- * authors       Alain Greiner (2016,2017,2018,2019,2020)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c) UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,199 +17,96 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
-#include <hal_special.h>
-#include <hal_uspace.h>
-#include <hal_vmm.h>
+#include <types.h>
 #include <errno.h>
 #include <thread.h>
-#include <printk.h>
+#include <task.h>
+#include <kmem.h>
 #include <vmm.h>
-#include <syscalls.h>
-#include <remote_barrier.h>
+#include <kmagics.h>
+#include <barrier.h>
 
-/////////////////////////////////////////////////////////////////////////////////
-// This function returns a printable string for the barrier related command type.
-/////////////////////////////////////////////////////////////////////////////////
+int sys_barrier(struct barrier_s **barrier, uint_t operation, uint_t count)
+{
+	kmem_req_t req;
+	struct barrier_s *ibarrier;
+	error_t err = EINVAL;
+  
+	if((err = vmm_check_address("usr barrier ptr", 
+				    current_task, 
+				    barrier,
+				    sizeof(struct barrier_s*))))
+		goto SYS_BARRIER_END;
 
-#if DEBUG_SYS_SOCKET || DEBUG_SYSCALLS_ERROR
-static char* barrier_cmd_str( uint32_t type )
+	if((err = cpu_copy_from_uspace(&ibarrier, barrier, sizeof(struct barrier_s *))))
+		goto SYS_BARRIER_END;
+
+	switch(operation)
+	{
+	case BARRIER_INIT_PRIVATE:
+	case BARRIER_INIT_SHARED:
+		req.type  = KMEM_BARRIER;
+		req.size  = sizeof(*ibarrier);
+		req.flags = AF_USER;
+
+		if((ibarrier = kmem_alloc(&req)) == NULL)
+		{
+			err = ENOMEM;
+			break;
+		}
+    
+		if((err = barrier_init(ibarrier, count, operation)))
+			break;
+    
+		if((err = cpu_copy_to_uspace(barrier, &ibarrier, sizeof(struct barrier_s *))))
+		{
+			req.ptr = ibarrier;
+			kmem_free(&req);
+		}
+		break;
+
+	case BARRIER_WAIT:
+
+		if((err = vmm_check_object(ibarrier, struct barrier_s, BARRIER_ID)))
+			break;
+
+		err = barrier_wait(ibarrier);
+		break;
+
+	case BARRIER_DESTROY:
+    
+		if((err = vmm_check_object(ibarrier, struct barrier_s, BARRIER_ID)))
+			break;
+    
+		if((err = barrier_destroy(ibarrier)))
+			break;
+   
+		req.type = KMEM_BARRIER;
+		req.ptr  = ibarrier;
+		kmem_free(&req);
+		return 0;
+
+	default:
+		err = EINVAL;
+	}
+
+SYS_BARRIER_END:
+	current_thread->info.errno = err;
+	return err;
+}
+
+KMEM_OBJATTR_INIT(barrier_kmem_init)
 {
-    if     ( type == BARRIER_INIT     ) return "INIT"; 
-    else if( type == BARRIER_WAIT     ) return "WAIT"; 
-    else if( type == BARRIER_DESTROY  ) return "DESTROY";
-    else                                return "undefined";
+	attr->type   = KMEM_BARRIER;
+	attr->name   = "KCM Barrier";
+	attr->size   = sizeof(struct barrier_s);
+	attr->aligne = 0;
+	attr->min    = CONFIG_BARRIER_MIN;
+	attr->max    = CONFIG_BARRIER_MAX;
+	attr->ctor   = NULL;
+	attr->dtor   = NULL;
+	return 0;
 }
-#endif
-
-//////////////////////////////////
-int sys_barrier( intptr_t   vaddr,
-                 uint32_t   operation,
-                 uint32_t   count,
-                 intptr_t   attr )   
-{
-	error_t                 error;
-    vseg_t                * vseg;
-    pthread_barrierattr_t   k_attr;
-
-    thread_t  * this    = CURRENT_THREAD;
-    process_t * process = this->process;
-
-#if DEBUG_SYS_BARRIER || DEBUG_SYSCALLS_ERROR || CONFIG_INSTRUMENTATION_SYSCALLS
-uint64_t     tm_start = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_BARRIER
-if( DEBUG_SYS_BARRIER < tm_start )
-printk("\n[%s] thread[%x,%x] enters for %s / count %d / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, barrier_cmd_str(operation), count,
-(uint32_t)tm_start );
-#endif
-
-    // check vaddr in user vspace
-	if( vmm_get_vseg( process , vaddr , &vseg ) )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start ) 
-printk("\n[ERROR] in %s for %s : unmapped barrier %x / thread[%x,%x]\n",
-__FUNCTION__, barrier_cmd_str(operation), vaddr, process->pid, this->trdid );
-#endif
-        this->errno = EINVAL;
-        return -1;
-    }
-
-    // execute requested operation
-	switch( operation )
-	{
-        //////////////////
-	    case BARRIER_INIT:
-        {
-            if( attr != 0 )   // QDT barrier required
-            {
-                if( vmm_get_vseg( process , attr , &vseg ) )
-                {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start ) 
-printk("\n[ERROR] in %s for INIT : unmapped barrier attributes %x / thread[%x,%x]\n",
-__FUNCTION__ , attr , process->pid , this->trdid );
-#endif
-                    this->errno = EINVAL;
-                    return -1;
-                }
-  
-                // copy barrier attributes into kernel space
-                hal_copy_from_uspace( XPTR( local_cxy , &k_attr ),
-                                      (void *)attr,
-                                      sizeof(pthread_barrierattr_t) );
-
-                if ( count != k_attr.x_size * k_attr.y_size *k_attr.nthreads )  
-                {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start ) 
-printk("\n[ERROR] in %s for INIT : count (%d) != x_size (%d) * y_size (%d) * nthreads (%x)\n",
-__FUNCTION__, count, k_attr.x_size, k_attr.y_size, k_attr.nthreads );
-#endif
-                    this->errno = EINVAL;
-                    return -1;
-                }
-  
-
-                // call relevant system function
-                error = generic_barrier_create( vaddr , count , &k_attr );
-            }
-            else               // simple barrier required
-            {
-                error = generic_barrier_create( vaddr , count , NULL );
-            }
-
-		    if( error )
-            {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start ) 
-printk("\n[ERROR] in %s for INIT : cannot create barrier %x / thread[%x,%x]\n",
-__FUNCTION__ , vaddr , process->pid , this->trdid );
-#endif
-                this->errno = ENOMEM;
-                return -1;
-            }
-			break;
-        }
-        //////////////////
-	    case BARRIER_WAIT:
-        {
-            xptr_t barrier_xp = generic_barrier_from_ident( vaddr );
-
-            if( barrier_xp == XPTR_NULL )     // user error
-            {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start ) 
-printk("\n[ERROR] in %s for WAIT : barrier %x not registered / thread[%x,%x]\n",
-__FUNCTION__ , (intptr_t)vaddr , process->pid, this->trdid );
-#endif
-                this->errno = EINVAL;
-                return -1;
-            }
-            else                          // success
-            {
-                generic_barrier_wait( barrier_xp ); 
-            }
-            break;
-        }
-        /////////////////////
-	    case BARRIER_DESTROY:
-        {
-            xptr_t barrier_xp = generic_barrier_from_ident( vaddr );
-
-            if( barrier_xp == XPTR_NULL )     // user error
-            {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start ) 
-printk("\n[ERROR] in %s for DESTROY : barrier %x not registered / thread[%x,%x]\n",
-__FUNCTION__ , (intptr_t)vaddr , process->pid, this->trdid );
-#endif
-                this->errno = EINVAL;
-                return -1;
-            }
-            else                          // success
-            {
-                generic_barrier_destroy( barrier_xp ); 
-            }
-            break;
-        }
-        ////////
-        default:
-        {
-            assert( __FUNCTION__, false, "illegal operation type <%x>", operation );
-        }
-	}  // end switch
-
-    hal_fence();
-
-#if (DEBUG_SYS_BARRIER || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_BARRIER
-if( DEBUG_SYS_BARRIER < tm_end )
-printk("\n[%s] thread[%x,%x] exit for %s / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, sys_barrier_op_str(operation), (uint32_t)tm_end );
-#endif
-
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_BARRIER] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_BARRIER] , 1 );
-#endif
-
-	return 0;
-
-}  // end sys_barrier()
-
Index: trunk/kernel/syscalls/sys_chdir.c
===================================================================
--- trunk/kernel/syscalls/sys_chdir.c	(revision 690)
+++ trunk/kernel/syscalls/sys_chdir.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_chdir.c - kernel function implementing the "chdir" syscall.
+ * sys_chdir: change process current work directory
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Author    Alain Greiner (2016,2017,2018, 2019)
+ * This file is part of ALMOS-kernel.
  *
- * Copyright (c) UPMC Sorbonne Universites
- *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,122 +17,45 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
-#include <chdev.h>
+#include <cpu.h>
+#include <device.h>
+#include <driver.h>
 #include <rwlock.h>
 #include <vfs.h>
-#include <errno.h>
+#include <sys-vfs.h>
 #include <thread.h>
-#include <printk.h>
-#include <process.h>
+#include <ku_transfert.h>
+#include <task.h>
 
-#include <syscalls.h>
+int sys_chdir (char *pathname)
+{
+	register error_t err = 0;
+	register struct thread_s *this;
+	register struct task_s *task;
+	struct ku_obj ku_path;
 
-/////////////////////////////////
-int sys_chdir ( char * pathname )
-{
-    error_t   error;
-    vseg_t  * vseg; 
-    xptr_t    root_inode_xp;
+	this = current_thread;
+	task = current_task;
 
-    char      kbuf[CONFIG_VFS_MAX_PATH_LENGTH];
-
-    thread_t  * this    = CURRENT_THREAD;
-    process_t * process = this->process;
-
-#if DEBUG_SYS_CHDIR || DEBUG_SYSCALLS_ERROR || CONFIG_INSTRUMENTATION_SYSCALLS
-uint64_t     tm_start = hal_get_cycles();
-#endif
-
-    // check pathname length
-    if( hal_strlen_from_uspace( pathname ) >= CONFIG_VFS_MAX_PATH_LENGTH )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : pathname too long / thread[%x,%x]\n",
-__FUNCTION__, process->pid, this->trdid );
-#endif
-        this->errno = EINVAL;
-        return -1;
-    }
-
-    // check pathname in user space
-    if( vmm_get_vseg( process, (intptr_t)pathname , &vseg ) )
+	if(!pathname)
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : user buffer unmapped %x for thread[%x,%x]\n",
-__FUNCTION__ , (intptr_t)pathname , process->pid, this->trdid );
-#endif
-		this->errno = EINVAL;
-        return -1;
+		this->info.errno = EINVAL;
+		return -1;
+	}	
+      
+	KU_BUFF(ku_path, pathname);
+	rwlock_wrlock(&task->cwd_lock);
+	
+	if((err = vfs_chdir(&ku_path, &task->vfs_cwd)))
+	{
+		rwlock_unlock(&task->cwd_lock);
+		this->info.errno = (err < 0) ? -err : err;
+		return -1;
 	}
-
-    // copy pathname in kernel space
-    hal_strcpy_from_uspace( XPTR( local_cxy , kbuf ),
-                            pathname,
-                            CONFIG_VFS_MAX_PATH_LENGTH );
-
-#if DEBUG_SYS_CHDIR
-if( DEBUG_SYS_CHDIR < (uint32_t)tm_start )
-printk("\n[%s] thread[%x,%x] enter for <%s> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, kbuf, (uint32_t)tm_start );
-#endif
-
-    // compute root inode for path 
-    if( kbuf[0] == '/' )                        // absolute path
-    {
-        // use extended pointer on VFS root inode
-        root_inode_xp = process->vfs_root_xp;
-    }
-    else                                        // relative path
-    {
-        // get cluster and local pointer on reference process
-        xptr_t      ref_xp  = process->ref_xp;
-        process_t * ref_ptr = (process_t *)GET_PTR( ref_xp );
-        cxy_t       ref_cxy = GET_CXY( ref_xp );
-
-        // use extended pointer on CWD inode
-        root_inode_xp = hal_remote_l64( XPTR( ref_cxy , &ref_ptr->cwd_xp ) );
-    }
-
-    // call the relevant VFS function
-    error = vfs_chdir( root_inode_xp , kbuf );
-
-    if( error )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s / thread[%x,%x] : cannot change CWD\n",
-__FUNCTION__ , process->pid , this->trdid );
-#endif
-        this->errno = error;
-        return -1;
-    }
-
-    hal_fence();
-
-#if (DEBUG_SYS_CHDIR || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_CHDIR
-if( DEBUG_SYS_CHDIR < tm_end )
-printk("\n[%s] thread[%x,%x] exit  / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, (uint32_t)tm_end );
-#endif
- 
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_CHDIR] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_CHDIR] , 1 );
-#endif
-
-    return 0;
+   
+	rwlock_unlock(&task->cwd_lock);
+	return 0;
 }
Index: trunk/kernel/syscalls/sys_chmod.c
===================================================================
--- trunk/kernel/syscalls/sys_chmod.c	(revision 690)
+++ trunk/kernel/syscalls/sys_chmod.c	(revision 1)
@@ -1,16 +1,14 @@
 /*
- * sys_chmod.c - Change file access rights.
- *
- * Author       Alain Greiner  (2016,2017,2018,2019,2020)
- *
+ * sys_chmod: change file mode
+ * 
  * Copyright (c) 2015 UPMC Sorbonne Universites
  *
- * This file is part of ALMOS-MKH.
+ * This file is part of ALMOS-kernel.
  *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,75 +16,46 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
-#include <hal_uspace.h>
+#include <cpu.h>
+#include <device.h>
+#include <driver.h>
+#include <rwlock.h>
 #include <vfs.h>
-#include <vmm.h>
-#include <printk.h>
+#include <sys-vfs.h>
 #include <thread.h>
-#include <process.h>
-#include <syscalls.h>
+#include <ku_transfert.h>
+#include <task.h>
 
-///////////////////////////////////
-int sys_chmod( char     * pathname,
-               uint32_t   rights __attribute__((unused)) )
+int sys_chmod (char *pathname, uint_t mode)
 {
-    char        kbuf[CONFIG_VFS_MAX_PATH_LENGTH];
+	register error_t err = 0;
+	register struct thread_s *this;
+	register struct task_s *task;
+	struct ku_obj ku_path;
 
-    thread_t  * this    = CURRENT_THREAD;
+	this = current_thread;
+	task = current_task;
 
-#if DEBUG_SYS_CHMOD || DEBUG_SYSCALLS_ERROR || CONFIG_INSTRUMENTATION_SYSCALLS
-process_t * process  = this->process;
-uint64_t    tm_start = hal_get_cycles();
-#endif
-
-    // check pathname length
-    if( hal_strlen_from_uspace( pathname ) >= CONFIG_VFS_MAX_PATH_LENGTH )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / pathname too long\n",
-__FUNCTION__, this->trdid, process->pid );
-#endif
-        this->errno = ENFILE;
-        return -1;
-    }
-
-    // copy pathname in kernel space
-    hal_strcpy_from_uspace( XPTR( local_cxy , kbuf ),
-                            pathname,
-                            CONFIG_VFS_MAX_PATH_LENGTH );
-
-
-
-
-    printk("\n[ERROR] in %s : not implemented yet\n", __FUNCTION__ );
-    return -1;
-
-
-
-
-    hal_fence();
-
-#if (DEBUG_SYS_CHMOD || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_CHMOD
-if( DEBUG_SYS_CHMOD < tm_end )
-printk("\n[%s] thread[%x,%x] exit for / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, (uint32_t)tm_end );
-#endif
- 
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_CHMOD] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_CHMOD] , 1 );
-#endif
-
-    return 0;
-
-}  // end sys_chmod()
+	if(!pathname || NOT_IN_USPACE(pathname))
+	{
+		this->info.errno = EINVAL;
+		return -1;
+	}	
+	
+      
+	KU_BUFF(ku_path, pathname);
+	rwlock_wrlock(&task->cwd_lock);
+	
+	if((err = vfs_chmod(&ku_path, &task->vfs_cwd, mode)))
+	{
+		rwlock_unlock(&task->cwd_lock);
+		this->info.errno = (err < 0) ? -err : err;
+		return -1;
+	}
+   
+	rwlock_unlock(&task->cwd_lock);
+	return 0;
+}
Index: trunk/kernel/syscalls/sys_clock.c
===================================================================
--- trunk/kernel/syscalls/sys_clock.c	(revision 1)
+++ trunk/kernel/syscalls/sys_clock.c	(revision 1)
@@ -0,0 +1,45 @@
+/*
+ * sys_clock: get system current time
+ * 
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <errno.h>
+#include <config.h>
+#include <cpu.h>
+#include <thread.h>
+
+int sys_clock(uint64_t *val)
+{
+	error_t err;
+	uint64_t cycles;
+
+	if((val == NULL) || NOT_IN_USPACE((uint_t)val))
+	{
+		err = EINVAL;
+		goto fail_inval;
+	}
+
+	cycles = cpu_get_cycles(current_cpu);
+	err    = cpu_copy_to_uspace(val, &cycles, sizeof(cycles));
+
+fail_inval:
+	current_thread->info.errno = err;
+	return err; 
+}
Index: trunk/kernel/syscalls/sys_close.c
===================================================================
--- trunk/kernel/syscalls/sys_close.c	(revision 690)
+++ trunk/kernel/syscalls/sys_close.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_close.c  kernel function implementing the <close> syscall
+ * sys_close.c  close a process open file
  * 
- * Author       Alain Greiner (2016,2017,2018,2019,2020)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c) UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,137 +17,40 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
-#include <hal_special.h>
+#include <cpu.h>
+#include <device.h>
+#include <driver.h>
 #include <vfs.h>
+#include <sys-vfs.h>
 #include <process.h>
 #include <thread.h>
-#include <ksocket.h>
-#include <printk.h>
+#include <config.h>
 
-#include <syscalls.h>
-
-///////////////////////////////
-int sys_close ( uint32_t fdid )
+/////////////////////////////
+int sys_close ( uint32_t fd )
 {
-    error_t            error;
-    xptr_t             file_xp;
-    cxy_t              file_cxy;
-    vfs_file_t       * file_ptr;
-    vfs_file_type_t   file_type;
-
-	thread_t  * this    = CURRENT_THREAD;
-	process_t * process = this->process;
-
-#if DEBUG_SYS_CLOSE || DEBUG_SYSCALLS_ERROR || CONFIG_INSTRUMENTATION_SYSCALLS
-uint64_t     tm_start = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_CLOSE
-if( DEBUG_SYS_CLOSE < (uint32_t)tm_start )
-printk("\n[%s] thread[%x,%x] enter / fdid %d / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, fdid, (uint32_t)tm_start );
-#endif
- 
-    // check fdid argument
-	if( fdid >= CONFIG_PROCESS_FILE_MAX_NR )
+	register process_t * process = current_process;
+	register thread_t  * this    = current_thread;
+	struct vfs_file_s  * file    = NULL;
+	error_t              err;
+  
+	if(( fd >= CONFIG_TASK_FILE_MAX_NR ) || (process_fd_lookup( process , fd , &file )))
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / illegal file descriptor index = %d\n",
-__FUNCTION__ , process->pid , this->trdid , fdid );
-#endif
-		this->errno = EBADFD;
+		this->info.errno = EBADFD;
 		return -1;
 	}
 
-    // get extended pointer on remote file descriptor
-    file_xp = process_fd_get_xptr_from_local( process , fdid );
-
-    if( file_xp == XPTR_NULL )
-    {
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / undefined file descriptor %d\n",
-__FUNCTION__ , process->pid , this->trdid , fdid );
-#endif
-        this->errno = EBADFD;
-		return -1;
-    }
-
-    // get file type
-    file_cxy  = GET_CXY( file_xp );
-    file_ptr  = GET_PTR( file_xp );
-    file_type = hal_remote_l32( XPTR( file_cxy , &file_ptr->type ) );
-
-    if( file_type == FILE_TYPE_DIR ) 
+	err = vfs_close( file , NULL );
+	if( err )
 	{
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / file descriptor %d is a directory\n",
-__FUNCTION__ , process->pid , this->trdid , fdid );
-#endif
-		this->errno = EBADFD;
-		return -1;
-	}
-    else if( file_type == FILE_TYPE_SOCK )
-    {
-        // call the relevant socket function
-        error = socket_close( file_xp , fdid );
-    }
-    else if( (file_type == FILE_TYPE_REG) ||
-             (file_type == FILE_TYPE_FIFO) )
-    {
-        // call the relevant VFS function
-	    error = vfs_close( file_xp , fdid );
-    }
-    else 
-    {
-           
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[WARNING] in %s : thread[%x,%x] / file_type (%s) unsupported / fdid %d\n",
-__FUNCTION__ , process->pid , this->trdid , vfs_inode_type_str(file_type) , fdid );
-#endif
-        error = 0;        
-    }
-
-	if( error )
-	{
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] cannot close file descriptor %d\n",
-__FUNCTION__ , process->pid , this->trdid , fdid );
-#endif
-		this->errno = error;
+		this->info.errno = err;
 		return -1;
 	}
 
-	hal_fence();
-
-#if (DEBUG_SYS_CLOSE || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_CLOSE
-tm_end = hal_get_cycles();
-if( DEBUG_SYS_CLOSE < tm_start )
-printk("\n[%s] thread[%x,%x] exit / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, (uint32_t)tm_end );
-#endif
- 
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_CLOSE] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_CLOSE] , 1 );
-#endif
-
+	process_fd_release( process , fd );
+	cpu_wbflush();
 	return 0;
 }
Index: trunk/kernel/syscalls/sys_closedir.c
===================================================================
--- trunk/kernel/syscalls/sys_closedir.c	(revision 690)
+++ trunk/kernel/syscalls/sys_closedir.c	(revision 1)
@@ -1,16 +1,15 @@
 /*
- * sys_closedir.c - Close an open VFS directory.
+ * sys_closedir.c close a process open directory
  * 
- * Author    Alain Greiner  (2016,2017,2018,2019,20120)
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
  *
- * Copyright (c) UPMC Sorbonne Universites
+ * This file is part of ALMOS-kernel.
  *
- * This file is part of ALMOS-MKH.
- *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,89 +17,35 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <kernel_config.h>
-#include <hal_kernel_types.h>
 #include <vfs.h>
-#include <printk.h>
+#include <sys-vfs.h>
 #include <thread.h>
 #include <process.h>
-#include <user_dir.h>
-#include <errno.h>
-#include <syscalls.h>
-#include <shared_syscalls.h>
 
-///////////////////////////////
-int sys_closedir ( DIR * dirp )
+////////////////////////////////
+int sys_closedir ( uint32_t fd )
 {
-    xptr_t         dir_xp;       // extended pointer on user_dir_t structure
-    user_dir_t   * dir_ptr;      // local pointer on user_dir_t structure
-    cxy_t          dir_cxy;      // cluster identifier (inode cluster)
+	register thread_t  * this    = current-thread;
+	register process_t * process = current_process;
+	struct vfs_file_s  * file    = NULL;
+	error_t              err;
 
-	thread_t  * this    = CURRENT_THREAD;  // client thread
-	process_t * process = this->process;   // client process
+	if(( fd >= CONFIG_TASK_FILE_MAX_NR ) || (process_fd_lookup( process , fd , &file )))
+	{
+		this->info.errno = EBADFD;
+		return -1;
+	}
 
-#if DEBUG_SYS_CLOSEDIR || DEBUG_SYSCALLS_ERROR || CONFIG_INSTRUMENTATION_SYSCALLS
-uint64_t     tm_start = hal_get_cycles();
-#endif
+	err  = vfs_closedir( file , NULL );
+	if(err)
+	{
+		this->info.errno = (err < 0) ? -err : err;
+		return -1;
+	}
 
-#if DEBUG_SYS_CLOSEDIR
-if( DEBUG_SYS_CLOSEDIR < tm_start )
-printk("\n[%s] thread[%x,%x] enter for DIR <%x> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, dirp, (uint32_t)tm_start );
-#endif
- 
-    // get extended pointer on kernel user_dir_t structure from dirp
-    dir_xp  = user_dir_from_ident( (intptr_t)dirp );
-
-    if( dir_xp == XPTR_NULL )
-	{
-
-#if DEBUG_SYSCALLS_ERROR
-if( DEBUG_SYSCALLS_ERROR < (uint32_t)tm_start )
-printk("\n[ERROR] in %s : thread[%x,%x] / DIR pointer %x not registered\n",
-__FUNCTION__ , process->pid , this->trdid, dirp );
-#endif
-		this->errno = EINVAL;
-		return -1;
-	}	
-
-    // get cluster and local pointer for user_dir_t structure
-    dir_ptr = GET_PTR( dir_xp );
-    dir_cxy = GET_CXY( dir_xp );
-    
-    // delete both user_dir_t structure and dirent array
-    if( dir_cxy == local_cxy )
-    {
-        user_dir_destroy( dir_ptr,
-                          process->ref_xp );
-    }
-    else
-    {
-        rpc_user_dir_destroy_client( dir_cxy,
-                                     dir_ptr,
-                                     process->ref_xp );
-    }
-
-    hal_fence();
-
-#if (DEBUG_SYS_CLOSEDIR || CONFIG_INSTRUMENTATION_SYSCALLS)
-uint64_t     tm_end = hal_get_cycles();
-#endif
-
-#if DEBUG_SYS_CLOSEDIR
-if( DEBUG_SYS_CLOSEDIR < tm_end )
-printk("\n[%s] thread[%x,%x] exit for DIR <%x> / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, dirp, (uint32_t)tm_end );
-#endif
- 
-#if CONFIG_INSTRUMENTATION_SYSCALLS
-hal_atomic_add( &syscalls_cumul_cost[SYS_CLOSEDIR] , tm_end - tm_start );
-hal_atomic_add( &syscalls_occurences[SYS_CLOSEDIR] , 1 );
-#endif
-
-    return 0;
-
-}  // end sys_closedir()
+	process_fd_release( process , fd );
+	return 0;
+}
